
// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#include <sbkpep.h>
#include <sbkpepbuffer.h>

#define PYSIDE6_COMOPT_COMPRESS 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqobject.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <signalmanager.h>
#include <pysidemetafunction.h>
#include <pysideqenum.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "akonadicalendar_python.h"

// main header
#include "akonadi_fetchjobcalendar_wrapper.h"

// Wrappers providing overrides
#include "akonadi_calendarbase_wrapper.h"
#include "akonadi_todopurger_wrapper.h"
#include "akonadi_publishdialog_wrapper.h"

// Extra includes
#include <pysidesignal.h>

// Argument includes
#include <QString>
#include <qdatetime.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qtimezone.h>

#include <algorithm>
#include <cctype>
#include <cstring>
#include <iterator>
#include <set>
#include <type_traits>
#include <typeinfo>

using namespace Akonadi;

extern "C" {
static PyTypeObject *Sbk_Akonadi_FetchJobCalendar_TypeF(void)
{
    return SbkAkonadiCalendarTypeStructs[SBK_Akonadi_FetchJobCalendar_IDX].type;
}
} // extern "C"

// Native ---------------------------------------------------------

void FetchJobCalendarWrapper::resetPyMethodCache()
{
    std::fill(m_PyMethodCache.begin(), m_PyMethodCache.end(), nullptr);
}

FetchJobCalendarWrapper::FetchJobCalendarWrapper(::QObject * parent) : Akonadi::FetchJobCalendar(parent)
{
}

void FetchJobCalendarWrapper::childEvent(::QChildEvent * event)
{
    static const char *funcName = "childEvent";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_FetchJobCalendar_TypeF(), gil, funcName, m_PyMethodCache[0], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::childEvent(event);
    }
    TodoPurgerWrapper::sbk_o_childEvent("FetchJobCalendar", funcName, gil, pyOverride, event);
}

void FetchJobCalendarWrapper::connectNotify(const ::QMetaMethod & signal)
{
    static const char *funcName = "connectNotify";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_FetchJobCalendar_TypeF(), gil, funcName, m_PyMethodCache[1], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::connectNotify(signal);
    }
    TodoPurgerWrapper::sbk_o_connectNotify("FetchJobCalendar", funcName, gil, pyOverride, signal);
}

void FetchJobCalendarWrapper::customEvent(::QEvent * event)
{
    static const char *funcName = "customEvent";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_FetchJobCalendar_TypeF(), gil, funcName, m_PyMethodCache[2], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::customEvent(event);
    }
    TodoPurgerWrapper::sbk_o_customEvent("FetchJobCalendar", funcName, gil, pyOverride, event);
}

void FetchJobCalendarWrapper::customPropertyUpdate()
{
    static const char *funcName = "customPropertyUpdate";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_FetchJobCalendar_TypeF(), gil, funcName, m_PyMethodCache[3], nameCache));
    if (pyOverride.isNull()) {
        return this->::KCalendarCore::CustomProperties::customPropertyUpdate();
    }
    PublishDialogWrapper::sbk_o_accept("FetchJobCalendar", funcName, gil, pyOverride);
}

void FetchJobCalendarWrapper::customPropertyUpdated()
{
    static const char *funcName = "customPropertyUpdated";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_FetchJobCalendar_TypeF(), gil, funcName, m_PyMethodCache[4], nameCache));
    if (pyOverride.isNull()) {
        return this->::KCalendarCore::Calendar::customPropertyUpdated();
    }
    PublishDialogWrapper::sbk_o_accept("FetchJobCalendar", funcName, gil, pyOverride);
}

void FetchJobCalendarWrapper::disconnectNotify(const ::QMetaMethod & signal)
{
    static const char *funcName = "disconnectNotify";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_FetchJobCalendar_TypeF(), gil, funcName, m_PyMethodCache[5], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::disconnectNotify(signal);
    }
    TodoPurgerWrapper::sbk_o_connectNotify("FetchJobCalendar", funcName, gil, pyOverride, signal);
}

void FetchJobCalendarWrapper::doSetTimeZone(const ::QTimeZone & timeZone)
{
    static const char *funcName = "doSetTimeZone";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_FetchJobCalendar_TypeF(), gil, funcName, m_PyMethodCache[6], nameCache));
    if (pyOverride.isNull()) {
        return this->::KCalendarCore::MemoryCalendar::doSetTimeZone(timeZone);
    }
    CalendarBaseWrapper::sbk_o_doSetTimeZone("FetchJobCalendar", funcName, gil, pyOverride, timeZone);
}

void FetchJobCalendarWrapper::endBatchAdding()
{
    static const char *funcName = "endBatchAdding";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_FetchJobCalendar_TypeF(), gil, funcName, m_PyMethodCache[7], nameCache));
    if (pyOverride.isNull()) {
        return this->::Akonadi::CalendarBase::endBatchAdding();
    }
    PublishDialogWrapper::sbk_o_accept("FetchJobCalendar", funcName, gil, pyOverride);
}

bool FetchJobCalendarWrapper::event(::QEvent * event)
{
    static const char *funcName = "event";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_FetchJobCalendar_TypeF(), gil, funcName, m_PyMethodCache[8], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::event(event);
    }
    return TodoPurgerWrapper::sbk_o_event("FetchJobCalendar", funcName, gil, pyOverride, event);
}

bool FetchJobCalendarWrapper::eventFilter(::QObject * watched, ::QEvent * event)
{
    static const char *funcName = "eventFilter";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_FetchJobCalendar_TypeF(), gil, funcName, m_PyMethodCache[9], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::eventFilter(watched, event);
    }
    return TodoPurgerWrapper::sbk_o_eventFilter("FetchJobCalendar", funcName, gil, pyOverride, watched, event);
}

void FetchJobCalendarWrapper::incidenceUpdate(const ::QString & uid, const ::QDateTime & recurrenceId)
{
    static const char *funcName = "incidenceUpdate";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_FetchJobCalendar_TypeF(), gil, funcName, m_PyMethodCache[10], nameCache));
    if (pyOverride.isNull()) {
        return this->::KCalendarCore::MemoryCalendar::incidenceUpdate(uid, recurrenceId);
    }
    CalendarBaseWrapper::sbk_o_incidenceUpdate("FetchJobCalendar", funcName, gil, pyOverride, uid, recurrenceId);
}

void FetchJobCalendarWrapper::incidenceUpdated(const ::QString & uid, const ::QDateTime & recurrenceId)
{
    static const char *funcName = "incidenceUpdated";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_FetchJobCalendar_TypeF(), gil, funcName, m_PyMethodCache[11], nameCache));
    if (pyOverride.isNull()) {
        return this->::KCalendarCore::MemoryCalendar::incidenceUpdated(uid, recurrenceId);
    }
    CalendarBaseWrapper::sbk_o_incidenceUpdate("FetchJobCalendar", funcName, gil, pyOverride, uid, recurrenceId);
}

void FetchJobCalendarWrapper::startBatchAdding()
{
    static const char *funcName = "startBatchAdding";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_FetchJobCalendar_TypeF(), gil, funcName, m_PyMethodCache[12], nameCache));
    if (pyOverride.isNull()) {
        return this->::Akonadi::CalendarBase::startBatchAdding();
    }
    PublishDialogWrapper::sbk_o_accept("FetchJobCalendar", funcName, gil, pyOverride);
}

void FetchJobCalendarWrapper::timerEvent(::QTimerEvent * event)
{
    static const char *funcName = "timerEvent";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_FetchJobCalendar_TypeF(), gil, funcName, m_PyMethodCache[13], nameCache));
    if (pyOverride.isNull()) {
        return this->::QObject::timerEvent(event);
    }
    TodoPurgerWrapper::sbk_o_timerEvent("FetchJobCalendar", funcName, gil, pyOverride, event);
}

void FetchJobCalendarWrapper::virtual_hook(int id, void * data)
{
    static const char *funcName = "virtual_hook";
    static PyObject *nameCache[2] = {};
    Shiboken::GilState gil(false);
    Shiboken::AutoDecRef pyOverride(Sbk_GetPyOverride(this, Sbk_Akonadi_FetchJobCalendar_TypeF(), gil, funcName, m_PyMethodCache[14], nameCache));
    if (pyOverride.isNull()) {
        return this->::KCalendarCore::MemoryCalendar::virtual_hook(id, data);
    }
    CalendarBaseWrapper::sbk_o_virtual_hook("FetchJobCalendar", funcName, gil, pyOverride, id, data);
}

const QMetaObject *FetchJobCalendarWrapper::metaObject() const
{
    if (QObject::d_ptr->metaObject != nullptr)
        return QObject::d_ptr->dynamicMetaObject();
    SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this);
    if (pySelf == nullptr)
        return Akonadi::FetchJobCalendar::metaObject();
    return PySide::SignalManager::retrieveMetaObject(reinterpret_cast<PyObject *>(pySelf));
}

int FetchJobCalendarWrapper::qt_metacall(QMetaObject::Call call, int id, void **args)
{
    int result = Akonadi::FetchJobCalendar::qt_metacall(call, id, args);
    return result < 0 ? result : PySide::SignalManager::qt_metacall(this, call, id, args);
}

void *FetchJobCalendarWrapper::qt_metacast(const char *_clname)
{
    if (_clname == nullptr)
        return {};
    if (SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this)) {
        auto *obSelf = reinterpret_cast<PyObject *>(pySelf);
        if (PySide::inherits(Py_TYPE(obSelf), _clname))
            return static_cast<void *>(const_cast< FetchJobCalendarWrapper *>(this));
    }
    return Akonadi::FetchJobCalendar::qt_metacast(_clname);
}

FetchJobCalendarWrapper::~FetchJobCalendarWrapper()
{
    auto *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this, Sbk_Akonadi_FetchJobCalendar_TypeF());
    Shiboken::Object::destroy(wrapper, this);
}

// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_Akonadi_FetchJobCalendar_Init(PyObject *self, PyObject *args, [[maybe_unused]] PyObject *kwds)
{
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::Akonadi::FetchJobCalendar >()))
        return -1;

    FetchJobCalendarWrapper *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    [[maybe_unused]] Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_ParseTuple(args, "|O:FetchJobCalendar", &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: FetchJobCalendar::FetchJobCalendar(QObject*=)
    if (numArgs == 0) {
        overloadId = 0; // FetchJobCalendar(QObject*)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[0])))) {
        overloadId = 0; // FetchJobCalendar::FetchJobCalendar(QObject*=)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", SbkAkonadiCalendarTypeStructs[SBK_Akonadi_FetchJobCalendar_IDX]);

    // Resolve keyword arguments
    {
        if (kwds != nullptr && PyDict_Size(kwds) > 0) {
            static const Shiboken::ArgumentNameIndexMapping mapping[1] = {{"parent", 0}};
            if (!Shiboken::parseConstructorKeywordArguments(kwds, mapping, 1, errInfo, pyArgs)
                || (pyArgs[0] != nullptr && !((pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]), (pyArgs[0])))))) {
                Py_XINCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkAkonadiCalendarTypeStructs[SBK_Akonadi_FetchJobCalendar_IDX]);
            }
        }
    }

    // PyMI support
    [[maybe_unused]] const bool usesPyMI = Shiboken::callInheritedInit(self, args, errInfo.isNull() ? kwds : errInfo.object(), SbkAkonadiCalendarTypeStructs[SBK_Akonadi_FetchJobCalendar_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return -1;
        ::QObject *cppArg0 = nullptr;
        if (pythonToCpp[0])
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // FetchJobCalendar::FetchJobCalendar(QObject*=)
            void *addr = PySide::nextQObjectMemoryAddr();
            if (addr != nullptr) {
                cptr = new (addr) FetchJobCalendarWrapper(cppArg0);
                PySide::setNextQObjectMemoryAddr(nullptr);
            } else {
                cptr = new FetchJobCalendarWrapper(cppArg0);
            }

        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< Akonadi::FetchJobCalendar >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", SbkAkonadiCalendarTypeStructs[SBK_Akonadi_FetchJobCalendar_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::Object::setHasCppWrapper(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);

    // QObject setup
    PySide::Signal::updateSourceObject(self);
    const auto *metaObject = cptr->metaObject(); // <- init python qt properties
    if (!errInfo.isNull() && PyDict_Check(errInfo.object())) {
        if (!PySide::fillQtProperties(self, metaObject, errInfo, usesPyMI))
            return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkAkonadiCalendarTypeStructs[SBK_Akonadi_FetchJobCalendar_IDX]);
    };


    return 1;
}


static const char *Sbk_Akonadi_FetchJobCalendar_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_Akonadi_FetchJobCalendar_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static int Sbk_Akonadi_FetchJobCalendar_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    PySide::Feature::Select(self);
    if (value != nullptr && PyCallable_Check(value) != 0) {
        auto plain_inst = reinterpret_cast< ::Akonadi::FetchJobCalendar *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkAkonadiCalendarTypeStructs[SBK_Akonadi_FetchJobCalendar_IDX]), reinterpret_cast<SbkObject *>(self)));
        auto *inst = dynamic_cast<FetchJobCalendarWrapper *>(plain_inst);
        if (inst != nullptr)
            inst->resetPyMethodCache();
    }
    Shiboken::AutoDecRef pp(reinterpret_cast<PyObject *>(PySide::Property::getObject(self, name)));
    if (!pp.isNull())
        return PySide::Property::setValue(reinterpret_cast<PySideProperty *>(pp.object()), self, value);
    return PyObject_GenericSetAttr(self, name, value);
}

} // extern "C"

static int Sbk_Akonadi_FetchJobCalendar_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PyType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_Akonadi_FetchJobCalendar_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PyType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
static void * Sbk_Akonadi_FetchJobCalendarSpecialCastFunction(void *obj, PyTypeObject *desiredType)
{
    auto me = reinterpret_cast< ::Akonadi::FetchJobCalendar *>(obj);
    if (desiredType == Shiboken::Module::get(SbkAkonadiCalendarTypeStructs[SBK_Akonadi_CalendarBase_IDX]))
        return static_cast< ::Akonadi::CalendarBase *>(me);
    else if (desiredType == Shiboken::Module::get(SbkKCalendarCoreTypeStructs[SBK_KCalendarCore_MemoryCalendar_IDX]))
        return static_cast< ::KCalendarCore::MemoryCalendar *>(me);
    else if (desiredType == Shiboken::Module::get(SbkKCalendarCoreTypeStructs[SBK_KCalendarCore_Calendar_IDX]))
        return static_cast< ::KCalendarCore::Calendar *>(me);
    else if (desiredType == Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QObject_IDX]))
        return static_cast< ::QObject *>(me);
    else if (desiredType == Shiboken::Module::get(SbkKCalendarCoreTypeStructs[SBK_KCalendarCore_CustomProperties_IDX]))
        return static_cast< ::KCalendarCore::CustomProperties *>(me);
    else if (desiredType == Shiboken::Module::get(SbkKCalendarCoreTypeStructs[SBK_KCalendarCore_IncidenceBase_IncidenceObserver_IDX]))
        return static_cast< ::KCalendarCore::IncidenceBase::IncidenceObserver *>(me);
    return me;
}



// Class Definition -----------------------------------------------
extern "C" {

static PyType_Slot Sbk_Akonadi_FetchJobCalendar_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_Akonadi_FetchJobCalendar_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_Akonadi_FetchJobCalendar_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_Akonadi_FetchJobCalendar_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_Akonadi_FetchJobCalendar_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_Akonadi_FetchJobCalendar_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_Akonadi_FetchJobCalendar_spec = {
    "1:AkonadiCalendar.Akonadi.FetchJobCalendar",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_Akonadi_FetchJobCalendar_slots
};

} //extern "C"

static void *Sbk_Akonadi_FetchJobCalendar_typeDiscovery([[maybe_unused]] void *cptr, [[maybe_unused]] PyTypeObject *instanceType)
{
    if (instanceType == Shiboken::SbkType< ::QObject >())
        return dynamic_cast< ::Akonadi::FetchJobCalendar *>(reinterpret_cast< ::QObject *>(cptr));
    if (instanceType == Shiboken::SbkType< ::KCalendarCore::CustomProperties >())
        return dynamic_cast< ::Akonadi::FetchJobCalendar *>(reinterpret_cast< ::KCalendarCore::CustomProperties *>(cptr));
    if (instanceType == Shiboken::SbkType< ::KCalendarCore::IncidenceBase::IncidenceObserver >())
        return dynamic_cast< ::Akonadi::FetchJobCalendar *>(reinterpret_cast< ::KCalendarCore::IncidenceBase::IncidenceObserver *>(cptr));
    return {};
}


// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void FetchJobCalendar_PythonToCpp_FetchJobCalendar_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_Akonadi_FetchJobCalendar_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_FetchJobCalendar_PythonToCpp_FetchJobCalendar_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_Akonadi_FetchJobCalendar_TypeF()))
        return FetchJobCalendar_PythonToCpp_FetchJobCalendar_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *FetchJobCalendar_PTR_CppToPython_FetchJobCalendar(const void *cppIn)
{
    return PySide::getWrapperForQObject(reinterpret_cast<::Akonadi::FetchJobCalendar *>(const_cast<void *>(cppIn)), Sbk_Akonadi_FetchJobCalendar_TypeF());

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *Akonadi_FetchJobCalendar_SignatureStrings[] = {
    "AkonadiCalendar.Akonadi.FetchJobCalendar(self,parent:PySide6.QtCore.QObject=nullptr)",
    nullptr}; // Sentinel
#else
static constexpr size_t Akonadi_FetchJobCalendar_SignatureByteSize = 82;
static constexpr uint8_t Akonadi_FetchJobCalendar_SignatureBytes[82] = {
    0x78, 0xda, 0x73, 0xcc, 0xce, 0xcf, 0x4b, 0x4c, 0xc9, 0x74, 0x4e, 0xcc, 0x49, 0xcd, 0x4b, 0x49,
    0x2c, 0xd2, 0x73, 0x84, 0xf0, 0xf5, 0xdc, 0x52, 0x4b, 0x92, 0x33, 0xbc, 0xf2, 0x93, 0x60, 0x12,
    0x1a, 0xc5, 0xa9, 0x39, 0x69, 0x3a, 0x05, 0x89, 0x45, 0xa9, 0x79, 0x25, 0x56, 0x01, 0x95, 0xc1,
    0x99, 0x29, 0xa9, 0x66, 0x7a, 0x81, 0x25, 0xce, 0xf9, 0x45, 0xa9, 0x7a, 0x81, 0xfe, 0x49, 0x59,
    0xa9, 0xc9, 0x25, 0xb6, 0x79, 0xa5, 0x39, 0x39, 0x05, 0x25, 0x45, 0x9a, 0x5c, 0x00, 0x4a, 0xf9,
    0x1f, 0x1d
};
#endif

PyTypeObject *init_Akonadi_FetchJobCalendar(PyObject *enclosingClass)
{
    auto &typeStruct = SbkAkonadiCalendarTypeStructs[SBK_Akonadi_FetchJobCalendar_IDX];
    if (typeStruct.type != nullptr)
        return typeStruct.type;

    auto *base1 = reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkAkonadiCalendarTypeStructs[SBK_Akonadi_CalendarBase_IDX]));
    Shiboken::AutoDecRef Sbk_Akonadi_FetchJobCalendar_Type_bases(PyTuple_Pack(1, base1));

    PyTypeObject *pyType = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "FetchJobCalendar",
        "Akonadi::FetchJobCalendar*",
        &Sbk_Akonadi_FetchJobCalendar_spec,
        &Shiboken::callCppDestructor< Akonadi::FetchJobCalendar >,
        Sbk_Akonadi_FetchJobCalendar_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass);
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, Akonadi_FetchJobCalendar_SignatureStrings);
#else
    InitSignatureBytes(pyType, Akonadi_FetchJobCalendar_SignatureBytes, Akonadi_FetchJobCalendar_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_Akonadi_FetchJobCalendar_PropertyStrings);
    typeStruct.type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        FetchJobCalendar_PythonToCpp_FetchJobCalendar_PTR,
        is_FetchJobCalendar_PythonToCpp_FetchJobCalendar_PTR_Convertible,
        FetchJobCalendar_PTR_CppToPython_FetchJobCalendar);

    Shiboken::Conversions::registerConverterName(converter, "Akonadi::FetchJobCalendar");
    Shiboken::Conversions::registerConverterName(converter, "Akonadi::FetchJobCalendar*");
    Shiboken::Conversions::registerConverterName(converter, "Akonadi::FetchJobCalendar&");
    Shiboken::Conversions::registerConverterAlias(converter, "FetchJobCalendar");
    Shiboken::Conversions::registerConverterAlias(converter, "FetchJobCalendar*");
    Shiboken::Conversions::registerConverterAlias(converter, "FetchJobCalendar&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::Akonadi::FetchJobCalendar).name());
    Shiboken::Conversions::registerConverterName(converter, typeid(FetchJobCalendarWrapper).name());

    MultipleInheritanceInitFunction func = Shiboken::ObjectType::getMultipleInheritanceFunction(Shiboken::Module::get(SbkKCalendarCoreTypeStructs[SBK_KCalendarCore_Calendar_IDX]));
    Shiboken::ObjectType::setMultipleInheritanceFunction(Sbk_Akonadi_FetchJobCalendar_TypeF(), func);
    Shiboken::ObjectType::setCastFunction(Sbk_Akonadi_FetchJobCalendar_TypeF(), &Sbk_Akonadi_FetchJobCalendarSpecialCastFunction);
    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(pyType, &Sbk_Akonadi_FetchJobCalendar_typeDiscovery);

    PySide::Signal::registerSignals(pyType, &::Akonadi::FetchJobCalendar::staticMetaObject);
    Shiboken::ObjectType::setSubTypeInitHook(pyType, &PySide::initQObjectSubType);
    PySide::initDynamicMetaObject(pyType, &::Akonadi::FetchJobCalendar::staticMetaObject, sizeof(FetchJobCalendarWrapper));

    return pyType;
}
